#! /usr/bin/env python
# -*- coding: utf-8 -*-
####################
# Copyright (c) 2012-2017, SSI. All rights reserved.

import sys
sys.path.insert(1, './lib')

from twisted.internet import reactor
from twisted.internet.protocol import DatagramProtocol
from twisted.application.internet import MulticastServer


class SSDPListener(DatagramProtocol):

	def startProtocol(self):
		self.transport.setTTL(5)
		self.transport.joinGroup("239.255.255.250")
		print("SSDP Listener Started...")

	def datagramReceived(self, data, (address, port)):
		self.SSDPProcess(address, data)

	def SSDPProcess(self, address, data):
		message = {}
		message['address'] = address

		#if ("Sonos" in data) and ("NOTIFY" in data):
		if ("Sonos" in data):

			for line in data.split('\r\n'):
				if (len(line) > 0) and ("NOTIFY" not in line):
					(item, value)  = line.split(': ')
					message[item] = value
			
			print message

reactor.listenMulticast(1900, SSDPListener(), listenMultiple=True)
reactor.run()

